<template lang="pug">
  .root-shower
    my-photo-shower(
      :photos="items.filter(s => (s.active))"
      :dummies="dummies"
      :fadeOut="fadeOut"
      style="padding: 20px 0 200px"
    )
    //- ↓写真がガタつかないように無理やりプリレンダリング
    ul.preRender(style="position:absolute; left: -100px; top -9999px")
      li(
        style="display:inline"
        v-for="(item,index) in photos"
        v-bind:key="index"
      )
        img(
          width="1"
          :data-index="index"
          :src="item.path"
        )
</template>
<script>
import Router from 'vue-router'
import { mapActions, mapGetters } from 'vuex'
import firebase from 'firebase'
import MyPhotoShower from '@/components/organisms/PhotoShower'

import arrayShuffle from '@/util/shuffle'

export default {
  name: 'Shower',
  components: {
    MyPhotoShower
  },
  props: {
    shuffleInterval: {
      type: Number,
      default: () => 15000
      // default: () => 7000
    },
  },
  data() {
    return {
      dummies: [
        { name: 'dummy', path: require('@/assets/dummy.png') }
      ],
      shuffleTimer: null,
      items: null,
      fadeOut: false,
      isShufflable: false,
      pageYOffset: 0,
      height: 0,
      contentHeight: 0,
    }
  },
  computed: {
    ...mapGetters('Auth', {
      userName: 'userName',
      isApproved: 'isApproved'
    }),
    ...mapGetters('Photos', {
      photos: 'getPhotos',
      uploader: 'getUploader'
    })
  },
  mounted(){
    // 表示系
    this.init()
  },
  created() {
    // データ取得
    this.listen()
    this.listenPicker()
  },
  methods: {
    ...mapActions('Photos', {
      listen: 'listen',
      listenPicker: 'listenPicker',
    }),
    init: function() {
      const _this = this
      // setItems
      // const items = this.photos
      // this.items = items

      // 初回はランダム表示
      function forceSetItems(){
        const items = _this.photos
        _this.items = items
        setTimeout(function(){
          if(!_this.items.length){
            forceSetItems()
          }
        }, 500)
      }
      forceSetItems()
      

      // start shufle timer
      this.shuffleTimer = setInterval(function(){
        this.isShufflable = true
        // _this.shuffle()
      }, this.shuffleInterval )
      this.loop()
    },
    loop: function(){
      const _this = this
      this.loopTimer = setInterval(function(){
        _this.scroll()
      },80)
    },
    scroll: function(){
      this.pageYOffset = window.pageYOffset
      this.height = document.documentElement.clientHeight
      this.contentHeight = this.$el.getBoundingClientRect().height
      console.log(this.pageYOffset, this.height, this.contentHeight)
      if( this.pageYOffset + this.height == this.contentHeight ){
        this.shuffle()
      }
      window.scrollBy(0, 1)
    },
    stopInterval: function(){
      console.log("stop! shuffleInterval!!!")
      clearInterval(this.shuffleTimer);
    },
    shuffle: function() {
      const _this = this
      this.shufflable = false
      this.fadeOut = true
      setTimeout(function(){
        _this.items = []
        _this.$forceUpdate()
        const items = _this.photos.map(s => ({...s, seed: Math.random() }))

        setTimeout(function(){
          _this.fadeOut = false
          _this.items = arrayShuffle(items)
          _this.$forceUpdate()
        }, 10)

      }, 2000)

    },
    addItem: function(container, texture) {},
    animate: function(t = 0) {}
  }
}
</script>
<style lang="stylus" scoped>
.root-shower
  overflow hidden
  width 100%
</style>
